UserDictSync

UserDictSync Version 1.0 (1.0.4613.37052)

This software is provided "as is" without warranty of any kind. The author disclaims all warranties, either express or implied, including the warranties of merchantability and fitness for a particular purpose. In no event shall the author be liable for any damages whatsoever including direct, indirect, incidental, consequential, loss of business profits or special damages.

The UserDictSync application allows you to synchronize user dictionaries (aka user words, aka custom dictionaries, aka custom words).

The early verions of UserDictSync will only support en-US dictionaries. See also idea topic for details.

Author

Harald-René Flasch
mailto:hfr@hfrmobile.com
http://www.hfrmobile.com

Information

  • Idea
  • How it works
  • Licensing

Supported applications

  • Aspell (Notepad++, ...)
  • Firefox
  • Microsoft Office
  • TortoiseSVN
  • VisualAssist
  • Windows Live Mail
  • Windows Live Writer
  • Future applications

History

The following table contains all released versions of UserDictSync and short description for each version:

Version Description
1.0 (1.0.4613.37052)
  • Added Search command
  • Added 'Dirty' handling
1.0-RC4b (1.0.4467.37261)
  • Fixed satellite assembly resource issue
1.0-RC4 (1.0.4467.36327)
  • Internal improvements/refactoring
  • Changed licensing mode: No expiration date any more but limited functionality for trial mode
1.0-RC3 (1.0.4459.38730)
  • Added context menu items for opening user word lists with Notepad or Notepad++
  • Added Microsoft Office support
  • Added Windows Live Mail support
  • Improved help (specially the information about Notepad++/Aspell)
1.0-RC2 (1.0.1.3)
  • Added Aspell support
  • Suspended support for Lotus Notes
1.0-RC1 (1.0.1.2)
  • Enhanced trial period
1.0-Beta2b (1.0.1.1)
  • Moved Copy and Merge menu items to an Edit menu
  • Improved Help menu
  • Enhanced trial period
1.0-Beta2 (1.0.1.0)
  • Improved help
  • Added support for VisualAssist
1.0-Beta1 (1.0.0.0)
  • Initial version which comes with Copy and Merge feature and support for Firefox, TortoiseSVN and Windows Live Writer


UserDictSync: Idea

Idea

The idea why I have started developing UserDictSync is simple: I am using a lot of applications which offer "user words" (aka "custom dictionaries") for their spell checkers. Since I think it is waste of time to add the same words manually to each user word list of each application I searched for something that does this automatically for me. Since I found no application that does this for me the idea of UserDictSync was born.

Some applications only using one "custom dictionary" for all languages while others using separate "custom dictionary" files for each language. I am not sure which approach is better. Without UserDictSync the first approach is the better one of course. Since the idea of "custom dictionary" files is that users are able to add their own words which are the same in all languages I think it is better to have only one "custom dictionary" in an application. Just think about your name. My family for example name is "Flasch" which will be the same in German and English of course. Or think about application names like "TortoiseSVN" which will be always the same in all languages.


UserDictSync: How it works

How it works

When you start UserDictSync it will search for all supported user dictionary files. UserDictSync will only display a supported application if it already has an user dictionary file. If an application is not displayed even it is supported just use the "Add to dictionary" menu item within the application in order to create a user dictionary file.

Edit

Copy

Copies all words from the current selected application to all others. All words for the target applications will be replaced by the words from the source application. The operation will only be done in memory. You have to use Save All menu item in order to save the dictionaries.

Merge

Merges all words from all application/dictionaries so that all dictionaries will contain the same words. This will be the usual way you should use UserDictSync. The operation will only be done in memory. You have to use Save All menu item in order to save the dictionaries.

Search

Allows you to search for a specific word in the word lists. The search text can be provided in the text box in the tool strip bar.
Searches only within the current selected column.

File

Save All

Writes all changes you made with Copy and Merge to disk.

Application list

Context menu

Using the context menu item Open with Notepad or Open with Notepad++ you can open the current selected user word list in a text editor.


UserDictSync: Licensing

Licensing

Since I do the whole development of UserDictSync in my spare time I decided to provide UserDictSync as so called "donation ware".

If you like to use this application please make a donation as described on the product page.

If you are using the trial mode of the application (no expiration date any more since version 1.0-RC4) the application has some limitations:

  • Only a maximum of 99 words per supported appliction can be synced/saved
  • Some menu items are not available in trial mode
    • Edit | Search


UserDictSync: Aspell (Notepad++, ...)

Aspell (Notepad++, ...)

UserDictSync was tested with Aspell 1.5 (but UI/AboutBox says v1.1) (using Aspell English Dictionary-0.50-2 for Notepad++ by "Jens Lorenz") but should work with other versions and applications too.

GNU Aspell-0.50.3 (win32)

  • English: aspell-en-0.50-2-3.exe; Kevin Atkinson; Copyrighted
  • German: aspell-de-0.50-2-3.exe; Björn Jacke; GPL (you may get a 404 (not found) error but this is the link provided at aspell.net at the moment (2011-06-07))

APPDATA: Vista, Windows 7

When using UserDictSync under Vista or Windows 7 I recommend selecting the Don't use %APPDATA% option when installing NP++ since UserDictSync 1.0 menus "Open with Notepad" and "Open with Notepad++" will try to open the en.pws from the wrong location otherwise.

In order to use the Don't use %APPDATA% option check that option when installing NP++:
NP++ installer

CAUTION: When you already used UserDictSync before you should remove %LocalAppData%\VirtualStore\Program Files\Aspell\ otherwise UserDictSync will look at this location for word user-word files for synchronizing them with the others but Aspell will look at the user-words in the application directory!

Other tested versions

  • Notepad++ 5.6.8 / Spell-Checker plug-in for Notepad++ v5.1 / v1.3.3
  • Notepad++ 5.9.3 / Spell-Checker plug-in for Notepad++ v5.1 / v1.3.3

If you know why the Spell-Checker plug-in for Notepad++ has two version numbers (e.g. v5.1 / v1.3.3) please let let know. Thank you!

Applications using Aspell

  • Notepad++
  • If you know other apps or need support for additional apps let me know!

Problems / Solutions

If using Windows Vista or Windows 7 you may have troubles using GNU Aspell.

  • Problem:
    GNU Aspell: Cannot open for writing
    Solution:
    You need read+write access for the en.pws and en.prepl files.

    The first line of en.prepl must look like this: personal_repl-1.1 en 0
    (usually that file only consists of one line; I do not know what it is for, if you know it please let me know)

  • Problem:
    GNU Aspell: Not proper format
    Solution:
    The first line must look like: personal_ws-1.1 en 286

    en: Language code
    286: Number of words (lines) in the file

  • Problem:
    GNU Aspell: Invalid word
    Solution:
    Remove the invalid word(s)

Conclusion

Using UserDictSync the "invalid word" problem described above will not occur since UserDictSync only synchronizes words which only consists of letters.


UserDictSync: Firefox

Firefox

UserDictSync was tested with Firefox 3.6.12 but should also work with previous versions of Firefox and of course for future versions. Each Firefox profile gets his own user dictionary and so it will be displayed as own application in UserDictSync as "Firefox [profilename]".


UserDictSync: Microsoft Office

Microsoft Office

UserDictSync was tested with Word 2007 and Word 2010 under Windows XP Professional SP3, Windows Vista Ultimate and Windows 7 Enterprise.


UserDictSync: TortoiseSVN

TortoiseSVN

UserDictSync was tested with TortoiseSVN 1.6.6 but should also work with previous versions of TortoiseSVN and of course for future versions.


UserDictSync: VisualAssist

VisualAssist

UserDictSync was tested with VisualAssist 10.6.1837.0 (Whole Tomato Software) but should also work with previous versions of VisualAssist and of course for future versions.


UserDictSync: Windows Live Mail

Windows Live Mail

UserDictSync was only tested with Windows Live Mail 2011. I recommend using at least Windows Live Mail 2011 (Build 15.4.3538.0513).

Don't be confused about Windows Mail and Windows Live Mail. They are completely different programs. UserDictSync only supports Windows Live Mail since Microsoft has discontinued the old Windows Mail which automatically comes with Windows Vista.

If you know how to remove/hide Windows Mail under Vista just let me know!


UserDictSync: Windows Live Writer

Windows Live Writer

UserDictSync was only tested with Windows Live Writer 2011. I recommend using at least Windows Live Writer 2011 (Build 15.4.3502.922).


UserDictSync: Future

Supported applications for the future

  • PADGen
  • ReSpeller (a R# plug-in)
  • IBM Lotus Notes (8.5.2 or higher) - Suspended for the moment since I changed my employer and so I am not using Lotus Notes at the moment. If you like to use UserDictSync together with Lotus Notes just let me know.

If you like to have support for another application than listed here just write me an e-mail in order to determine if it is possible to add it to UserDictSync!


RCMD Author

Author

This is a "hidden" page about the author (me ;-)) of UserDictSync. You may click on the image on the author page of my homepage... ;-)

Picture of the author

Name: | Harald-René Flasch
Contact: | hfr@hfrmobile.com
Homepage: | http://www.hfrmobile.com